Package net.sf.saxon.tree.iter

## Class NodeWrappingAxisIterator<B>

- java.lang.Object
- - net.sf.saxon.tree.iter.NodeWrappingAxisIterator<B>

- Type Parameters:
    `B` - the class of the external nodes being wrapped.
  All Implemented Interfaces:
    `java.io.Closeable`, `java.lang.AutoCloseable`, `SequenceIterator`, `AxisIterator`, `LookaheadIterator`, `UnfailingIterator`

      public class NodeWrappingAxisIterator<B>
      extends java.lang.Object
      implements AxisIterator, LookaheadIterator

  An AxisIterator that wraps a Java Iterator.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.om.SequenceIterator

      `SequenceIterator.Property`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `NodeWrappingAxisIterator​(java.util.Iterator<? extends B> base, NodeWrappingFunction<? super B,​NodeInfo> wrappingFunction)` | Create a SequenceIterator over a given iterator

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.util.Iterator<? extends B>` | `getBaseIterator()` |
    `NodeWrappingFunction<? super B,​NodeInfo>` | `getNodeWrappingFunction()` |
    `java.util.EnumSet<SequenceIterator.Property>` | `getProperties()` | Get properties of this iterator, as a bit-significant integer.
    `boolean` | `hasNext()` | Determine whether there are more items to come.
    `boolean` | `isIgnorable​(B node)` |
    `NodeInfo` | `next()` | Get the next item in the sequence.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.tree.iter.AxisIterator

      `asIterator, forEachNode`

    - ### Methods inherited from interface net.sf.saxon.om.SequenceIterator

      `close, forEachOrFail, materialize`

    - ### Methods inherited from interface net.sf.saxon.tree.iter.UnfailingIterator

      `forEach, toList`

- - ### Constructor Detail

    - #### NodeWrappingAxisIterator

          public NodeWrappingAxisIterator​(java.util.Iterator<? extends B> base,
                                          NodeWrappingFunction<? super B,​NodeInfo> wrappingFunction)

      Create a SequenceIterator over a given iterator
      Parameters:
        `base` - the base Iterator
        `wrappingFunction` - a function that wraps objects of type B in a Saxon NodeInfo

  - ### Method Detail

    - #### getBaseIterator

          public java.util.Iterator<? extends B> getBaseIterator()

    - #### getNodeWrappingFunction

          public NodeWrappingFunction<? super B,​NodeInfo> getNodeWrappingFunction()

    - #### hasNext

          public boolean hasNext()

      Description copied from interface: `LookaheadIterator`
      Determine whether there are more items to come. Note that this operation is stateless and it is not necessary (or usual) to call it before calling next(). It is used only when there is an explicit need to tell if we are at the last element.

      This method must not be called unless the result of getProperties() on the iterator includes the property `SequenceIterator.Property.LOOKAHEAD`

      Specified by:
        `hasNext` in interface `LookaheadIterator`
      Returns:
        true if there are more items in the sequence

    - #### next

          public NodeInfo next()

      Description copied from interface: `UnfailingIterator`
      Get the next item in the sequence.
      Specified by:
        `next` in interface `AxisIterator`
      Specified by:
        `next` in interface `SequenceIterator`
      Specified by:
        `next` in interface `UnfailingIterator`
      Returns:
        the next Item. If there are no more items, return null.

    - #### isIgnorable

          public boolean isIgnorable​(B node)

    - #### getProperties

          public java.util.EnumSet<SequenceIterator.Property> getProperties()

      Get properties of this iterator, as a bit-significant integer.
      Specified by:
        `getProperties` in interface `SequenceIterator`
      Returns:
        the properties of this iterator. This will be some combination of properties such as `SequenceIterator.Property.GROUNDED`, `SequenceIterator.Property.LAST_POSITION_FINDER`, and `SequenceIterator.Property.LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.